package com.compomics.util.experiment.identification;

import java.io.*;
import java.sql.*;

/**
 * Deby database tests.
 *
 * @author Harald Barsnes
 */
public class DerbyTest {

    Connection dbConnection = null;

    public static void main(String[] args) throws Exception {
        new DerbyTest().start();
    }

    private void start() {
        createDatebase();
        //connectToDatabase();
        createTables();

        /*
         * System.out.println("deleting all rows..."); deleteAllRows();
         *
         * System.out.println("inserting data..."); insertData();
         *
         * System.out.println("printing data..."); //getData();
         */
        
        getData();
    }

    public void insertData(String matchKey, Object object) {

        try {
            PreparedStatement ps = dbConnection.prepareStatement("INSERT INTO MyTable VALUES (?, ?)");
            ps.setString(1, matchKey);

            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(bos);
            oos.writeObject(object);
            oos.close();
            ps.setBytes(2, bos.toByteArray());

            ps.execute();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void insertData() {

        try {
            PreparedStatement ps = dbConnection.prepareStatement("INSERT INTO MyTable VALUES (?, ?)");

            for (int i = 0; i < 100000; i++) {

                ps.setString(1, "TestA " + i);

                ByteArrayOutputStream bos = new ByteArrayOutputStream();
                ObjectOutputStream oos = new ObjectOutputStream(bos);
                //oos.writeObject(new String("another string"));
                oos.writeObject(new File("test_file"));
                oos.close();
                ps.setBytes(2, bos.toByteArray());

                ps.execute();

                if (i % 1000 == 0) {
                    System.out.println(i);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void deleteAllRows() {
        try {
            Statement statement = dbConnection.createStatement();
            statement.execute("DELETE FROM MyTable");
        } catch (SQLException ex) {
            ex.printStackTrace();
        }
    }

    private void getData() {
        try {
            Statement stmt = dbConnection.createStatement();
            ResultSet results = stmt.executeQuery("select * from " + "MyTable");
            ResultSetMetaData rsmd = results.getMetaData();
            int numberCols = rsmd.getColumnCount();

            for (int i = 1; i <= numberCols; i++) {
                //print Column Names
                System.out.print(rsmd.getColumnLabel(i) + "\t");
            }

            System.out.println("\n-------------------------------------------------");

            while (results.next()) {
                String name = results.getString(1);
                Blob tempBlob = results.getBlob(2);

                // convert blob to data again
                BufferedInputStream bis = new BufferedInputStream(tempBlob.getBinaryStream());
                ObjectInputStream in = new ObjectInputStream(bis);
                Object object = in.readObject();
                in.close();

                if (object instanceof String) {
                    System.out.println(name + "\t\t" + ((String) object).toString() + "(" + ((String) object).length() + ")");
                } else if (object instanceof File) {
                    System.out.println(name + "\t\t" + ((File) object).getName());
                } else {
                    System.out.println(name + "\t\t" + object);
                }
            }

            results.close();
            stmt.close();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void createDatebase() {

        String strUrl = "jdbc:derby:DebyTestDb;create=true";

        try {
            dbConnection = DriverManager.getConnection(strUrl);
        } catch (SQLException ex) {
            ex.printStackTrace();
        }
    }

    public void connectToDatabase() {
        String strUrl = "jdbc:derby:DebyTestDb";
//        Properties props = new Properties();
//        props.put("user", "dbuser");
//        props.put("password", "dbuserpwd");

        try {
            //dbConnection = DriverManager.getConnection(strUrl, props);
            dbConnection = DriverManager.getConnection(strUrl);
        } catch (SQLException sqle) {
            sqle.printStackTrace();
        }
    }

    private boolean createTables() {
        boolean bCreatedTables = false;

        try {
            Statement statement = dbConnection.createStatement();
            statement.execute("CREATE table MyTable ("
                    + "NAME    VARCHAR(200),"
                    + "BLOB blob(16M)" // @TODO: not sure what the size should be here...
                    + ")");
            bCreatedTables = true;
        } catch (SQLException ex) {
            ex.printStackTrace();
        }

        return bCreatedTables;
    }
}
